#include <jni.h>
#include "JNIWrapper.h"
#include <stdio.h>
#include "slalib.h"

/**
 * SLALIB s l a D e 2 h - Equatorial to horizon coordinates: HA,Dec to Az,El
 *
 * @version 15 August 2001
 * @author C. Mavros for ESO
 *
 * @param ha double hour angle
 * @param dec double declination
 * @param phi double observatory latitude
 * returned Array of doubles [2] az azimuth el elevation
 */

JNIEXPORT jdoubleArray JNICALL Java_org_eso_ohs_phase2_visiplot_JNIWrapper_jnislaDe2h
  (JNIEnv * env , jobject obj, jdouble jHA, jdouble jdec, jdouble jphi){

    double jp[2];
    jdoubleArray jpArray = (*env)->NewDoubleArray(env,2);
    double az, el;
    double *az_ptr, *el_ptr;

    az_ptr = &az;
    el_ptr = &el;

    /** Call slaDe2h */
    slaDe2h (jHA, jdec, jphi, az_ptr, el_ptr );

    /* Pass pointers to array */
    jp[0]=az;
    jp[1]=el;

    (*env)->SetDoubleArrayRegion(env, jpArray, 0, 2, jp);

    return(jpArray);

}
