#include <jni.h>
#include "JNIWrapper.h"
#include <stdio.h>
#include "slalib.h"

/**
 * SLALIB s l a D m o o n - Approximate geocentric position and velocity of the Moon
 *
 * @version 15 August 2001
 * @author C. Mavros for ESO
 * @param date double Modified Julian Date (JD-2400000.5)
 *
 * @return Array of doubles[6] Moon x,y,z,xdot,ydot,zdot,
 * @return mean equator and equinox of date (AU, AU/s)
 */
 
JNIEXPORT jdoubleArray JNICALL Java_org_eso_ohs_phase2_visiplot_JNIWrapper_jnislaDmoon
  (JNIEnv * env, jobject jobj, jdouble jJD){

    int i = 0;
    double jRTN[6];
    jdoubleArray jpArray = (*env)->NewDoubleArray(env,6);

    slaDmoon ( jJD, jRTN );
    (*env)->SetDoubleArrayRegion(env, jpArray, 0, 6, jRTN);
    return(jpArray);

}
