#include <jni.h>
#include "JNIWrapper.h"
#include <stdio.h>
#include "slalib.h"

/*
 * SLALIB s l a D s e p -  Angle between two points on a sphere.
 * (The spherical coordinates are [RA,Dec], [Long,Lat] etc, in radians.)
 *
 * @version 15 August 2001
 * @author C. Mavros for ESO
 * @param a1,b1    double    spherical coordinates of one point
 * @param a2,b2    double    spherical coordinates of the other point
 *
 * @return the angle between the two points (radians)
 *
 */
 
JNIEXPORT jdouble JNICALL Java_org_eso_ohs_phase2_visiplot_JNIWrapper_jnislaDsep
  (JNIEnv * env, jobject jobj, jdouble jd1, jdouble jd2, jdouble jd3, jdouble jd4){

    return (slaDsep(jd1, jd2, jd3, jd4));

}
