#include <jni.h>
#include "JNIWrapper.h"
#include <stdio.h>
#include "slalib.h"

/*
 *  SLALIB s l a G m s t a - Conversion from Universal Time to Greenwich mean
 *          sidereal time, with rounding errors minimized.
*
 * @version 15 August 2001
 * @author C. Mavros for ESO
 *
 * @param date double UT1 date (MJD: integer part of JD-2400000.5))
 * @param ut double UT1 time (fraction of a day)
 *
 * @return Greenwich Mean Sidereal Time (double,radians, in the range 0 to 2pi)
 *
 */

JNIEXPORT jdouble JNICALL Java_org_eso_ohs_phase2_visiplot_JNIWrapper_jnislaGmsta
  (JNIEnv * env, jobject jobj, jdouble jJD, jdouble jJDfrac){

    return(slaGmsta (jJD, jJDfrac));

   }
