#include <jni.h>
#include "JNIWrapper.h"
#include <stdio.h>
#include "slalib.h"

/**
 *  Slalib function
 * 
 *  HA, Dec to Zenith Distance.
 *
 *  @version 25 July 2001
 *  @author C. Mavros for ESO
 *
 *  @param  jHA   double  Hour Angle in radians
 *  @param  jdec  double  declination in radians
 *  @param  jphi  double  observatory latitude in radians
 *  @return zenith angle in radians
 */

JNIEXPORT jdouble JNICALL Java_org_eso_ohs_phase2_visiplot_JNIWrapper_jnislaZenith
  (JNIEnv * env, jobject jobj, jdouble jHA, double jdec, double jphi){

    return (slaZd(jHA, jdec, jphi));

}

