//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// COPYRIGHT (c) 1996 European Southern Observatory
// LICENSE
//
// PROJECT:   VLT Data Flow System
// AUTHOR:    Jeremy Maxfield
// SUBSYSTEM: Dataflow core
// CI NUMBER: DFS-DFC-XXX
//
// $Revision: 1.2 $
// $Log: DfcCaseExpression.h,v $
// Revision 1.2  2004/10/26 15:23:54  nferguso
// Temporary check-in for repository move.
//
// Revision 1.1  2004/09/06 14:35:21  cguirao
// *** empty log message ***
//
// Revision 1.1  2004/09/02 14:35:20  cguirao
// *** empty log message ***
//
// Revision 1.1  2004/06/24 13:12:15  cguirao
// First check in
//
// Revision 1.2  1998/06/30 08:57:36  dataflow
// Removing $NAME
//
// Revision 1.1  1996/12/20 11:40:48  dfadmin
// Initial revision
//
//-----------------------------------------------------------------------------

#ifndef _DFC_CASE_EXPRESSION_H_
#define _DFC_CASE_EXPRESSION_H_

#include <DfcParsable.h>
#include <DfcParseString.h>

class DfcCaseExpression: public DfcParsable
{
   public:

     DfcCaseExpression();

     DfcCaseExpression(const DfcCaseExpression& other);
     DfcCaseExpression& operator=(const DfcCaseExpression& other);
     int  operator==(const DfcCaseExpression& other);

     DfsCString getLabel()const;
     DfsCString getAction()const;
 
     bool parse(DfcParseString& inString);

     void testPrint(std::ostream& outStream)const;

   private:
     DfsCString label;
     DfsCString action;

     DfsCString CASE_STRING;
     DfsCString FIRE_STRING;
};

#endif
