//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// COPYRIGHT (c) 1996 European Southern Observatory
// LICENSE
//
// PROJECT:   VLT Data Flow System
// AUTHOR:    Jeremy Maxfield
// SUBSYSTEM: Dataflow core
// CI NUMBER: DFS-DFC-XXX
//
// $Revision: 1.2 $
// $Log: DfcComparison.h,v $
// Revision 1.2  2004/10/26 15:23:54  nferguso
// Temporary check-in for repository move.
//
// Revision 1.1  2004/09/06 14:35:21  cguirao
// *** empty log message ***
//
// Revision 1.1  2004/09/02 14:35:20  cguirao
// *** empty log message ***
//
// Revision 1.1  2004/06/24 13:12:15  cguirao
// First check in
//
// Revision 1.2  1998/06/30 08:57:37  dataflow
// Removing $NAME
//
// Revision 1.1  1996/12/20 11:40:48  dfadmin
// Initial revision
//
//-----------------------------------------------------------------------------

#ifndef _DFC_COMPARISON_H_
#define _DFC_COMPARISON_H_

#include "DfsTValSlist.h"
#include <DfcParsable.h>
#include <DfcParseString.h>

class DfcComparison: public DfcParsable
{
   public:

     DfcComparison();

     DfcComparison(const DfcComparison& other);
     DfcComparison& operator=(const DfcComparison& other);
     int  operator==(const DfcComparison& other);

     DfsCString getName()const;
     DfsCString getComparitor()const;
     DfsCString getValue()const;
     DfsCString getAsString()const;
 
     bool parse(DfcParseString& inString);

     void testPrint(std::ostream& outStream)const;

   private:
     bool parseComparison(DfcParseString& inString);

     DfsCString name;
     DfsCString comparitor;
     DfsCString value;

     DfsCString EQUAL_STRING;
     DfsCString NOT_EQUAL_STRING;
     DfsCString GREATER_STRING;
     DfsCString LESS_STRING;
     DfsCString GREATER_OR_EQUAL_STRING;
     DfsCString LESS_OR_EQUAL_STRING;

     DfsTValSlist<DfsCString> validComparitors;
};

#endif
