//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//COPYRIGHT (c) 1996 European Southern Observatory
//LICENSE
//
//PROJECT:   VLT On-line Data Flow
//AUTHOR:    Michael Wiedmer - ESO/DMD/DPG
//SUBSYSTEM: Dataflow Core
//
//$Revision: 1.1 $
//$Log: DfcConstraint.h,v $
//Revision 1.1  2004/09/06 14:35:21  cguirao
//*** empty log message ***
//
//Revision 1.1  2004/09/02 14:35:20  cguirao
//*** empty log message ***
//
//Revision 1.1  2004/06/24 13:12:15  cguirao
//First check in
//
//Revision 1.2  1998/06/30 08:57:37  dataflow
//Removing $NAME
//
//Revision 1.1  1997/04/10 09:14:00  dfadmin
//Initial revision
//
//Revision 1.7  1996/12/13 14:22:36  mwiedmer
//add save() and load()
//
//Revision 1.6  1996/10/11 08:49:51  mwiedmer
//add friend void utest_DfcConstant()
//
//Revision 1.5  1996/09/10 11:56:32  mwiedmer
//standardised
//
//Revision 1.4  1996/09/10 11:53:39  mwiedmer
//standardised
//
//Revision 1.3  1996/09/09 13:11:59  mwiedmer
//added evaluate()
//
//Revision 1.2  1996/09/03 14:41:28  mwiedmer
//added RCS Name tag
//
//Revision 1.1  1996/09/02 12:18:21  dfadmin
//Update project structure
//
//Revision 1.1  1996/09/02 09:43:37  mwiedmer
//first release
//
//-----------------------------------------------------------------------------

#ifndef DFC_CONSTRAINT_H
#define DFC_CONSTRAINT_H

// includes from this library
// includes from other ESO libraries
#include <CorBase.h>
// includes from other libraries
// system includes

// typedef, extern, enums
// variables: consts, statics, exported variables (declared extern elsewhere)
// local forward function declarations
class DfcValue;
class CorStream;

/// constraints
class DfcConstraint : public CorBase {
  /**
  {\footnotesize $Id: DfcConstraint.h,v 1.1 2004/09/06 14:35:21 cguirao Exp $ } \\

  {\large SYNOPSIS} \\
  \begin{verbatim}
    #include <DfcConstraint.h>
  
    DfcConstraint myObject;
  \end{verbatim}

  {\large DESCRIPTION} \\
  This class models some arbitray constraints.

  {\large CAUTIONS} \\
  <optional> \\

  {\large EXAMPLES} \\
  <optional> \\

  {\large SEE ALSO} \\
  \Ref{CorBase}\\
  */

public:

  /// 
  DfcConstraint();
  /** {\large Purpose} \\
  The default c'tor.

  {\large Preconditions} \\
  \begin{itemize}
  \item Itemize this section if necessary. Remove itemization otherwise.
  \end{itemize}

  {\large Exceptions}\\
  \begin{itemize}
  \item Itemize this section if necessary. Remove itemization otherwise.
  \end{itemize}
  */
    

  /// 
  DfcConstraint(
    /** {\large Purpose} \\
    The copy c'tor creates a new instance from a reference.

    {\large Preconditions} \\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Exceptions}\\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Arguments}\\
    */
    ///
    const DfcConstraint& aRef
    /** the reference instance */
  );
    

  /// 
  DfcConstraint& operator=(
    /** {\large Purpose} \\
    The assignment operator makes this instance look like another one.

    {\large Preconditions} \\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Returns}\\
    A reference to this instance.

    {\large Exceptions}\\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Arguments}\\
    */
    ///
    const DfcConstraint& aRef
    /** the reference instance */
  );
    

  ///
  virtual ~DfcConstraint();
  /** {\large Purpose} \\
  The d'tor.
  
  {\large Preconditions} \\
  \begin{itemize}
  \item Itemize this section if necessary. Remove itemization otherwise.
  \end{itemize}
  
  {\large Exceptions}\\
  \begin{itemize}
  \item Itemize this section if necessary. Remove itemization otherwise.
  \end{itemize}
  */

  /// 
  virtual CorBool evaluate(
    /** {\large Purpose} \\
    Query whether the supplied value fits the constraints.

    {\large Preconditions} \\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Returns}\\
    This function returns corTRUE if the value fits the constraints.

    {\large Exceptions}\\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Arguments}\\
    */
    ///
    const DfcValue& aVal
    /** value to check */
  ) const;
    

  ///
  CorBool save(
    /** {\large Purpose} \\
    Save the contents of this instance to a stream.

    {\large Preconditions} \\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Returns}\\
    This function returns corTRUE on success.

    {\large Exceptions}\\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}
    */
    ///
    CorStream& aStream
    /** stream to save the constraint to */
  );


  ///
  CorBool load(
    /** {\large Purpose} \\
    Load the contents of this instance from a stream.

    {\large Preconditions} \\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Returns}\\
    This function returns corTRUE on success.

    {\large Exceptions}\\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}
    */
    ///
    CorStream& aStream
    /** stream to load the constraint from */
  );


protected:

private:
  friend void utest_DfcConstraint(CorUnitTest&); // the unit test function
};

#endif // DFC_CONSTRAINT_H
