//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// COPYRIGHT (c) 1996 European Southern Observatory
// LICENSE
//
// PROJECT:   VLT Data Flow System
// AUTHOR:    Jeremy Maxfield
// SUBSYSTEM: Dataflow Core
// CI NUMBER: DFS-DFC-XXX
//
// $Revision: 1.2 $
// $Log: DfcDataDefinitionFile.h,v $
// Revision 1.2  2004/10/26 15:23:54  nferguso
// Temporary check-in for repository move.
//
// Revision 1.1  2004/09/06 14:35:21  cguirao
// *** empty log message ***
//
// Revision 1.1  2004/09/02 14:35:20  cguirao
// *** empty log message ***
//
// Revision 1.1  2004/06/24 13:12:15  cguirao
// First check in
//
// Revision 1.2  1998/06/30 08:57:38  dataflow
// Removing $NAME
//
// Revision 1.1  1996/12/20 11:40:49  dfadmin
// Initial revision
//
//
//-----------------------------------------------------------------------------

#ifndef _DFC_DATA_DEFINITION_FILE_H_
#define _DFC_DATA_DEFINITION_FILE_H_

#include <DfcDataDefinition.h>
#include <DfcDefinitionFile.h>

class DfcDataDefinitionFile : public DfcDefinitionFile
{
   public:
      DfcDataDefinitionFile();

      DfcDataDefinitionFile(const DfcDataDefinitionFile& other);

      DfcDataDefinitionFile& operator=(const DfcDataDefinitionFile& other);

      int operator==(const DfcDataDefinitionFile& other);

      DfsTValSlist<DfcDataDefinition> getGeneralDefinitions()const;
      DfsTValSlist<DfcDataDefinition> getFrameDefinitions()const;
      DfsTValSlist<DfcDataDefinition> getTableDefinitions()const;

      bool open(const DfsCString& name);

      void testPrint(std::ostream& outStream)const;

   private:
      DfsCString GENERAL_STRING;
      DfsCString FRAME_STRING;
      DfsCString TABLE_STRING;

      DfsTValSlist<DfcDataDefinition> generalList;
      DfsTValSlist<DfcDataDefinition> frameList;
      DfsTValSlist<DfcDataDefinition> tableList;
};

#endif

