//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//COPYRIGHT (c) 1996 European Southern Observatory
//LICENSE
//
//PROJECT:   VLT On-line Data Flow
//AUTHOR:    Michael Wiedmer - ESO/DMD/DPG
//SUBSYSTEM: Dataflow Core
//
//$Revision: 1.2 $
//$Log: DfcDbData.h,v $
//Revision 1.2  2004/10/26 15:23:54  nferguso
//Temporary check-in for repository move.
//
//Revision 1.1  2004/09/06 14:35:22  cguirao
//*** empty log message ***
//
//Revision 1.1  2004/09/02 14:35:20  cguirao
//*** empty log message ***
//
//Revision 1.1  2004/06/24 13:12:15  cguirao
//First check in
//
//Revision 1.4  1999/06/23 14:52:46  adisaro
//validity management
//PAF content extraction
//
//Revision 1.3  1998/06/30 08:57:39  dataflow
//Removing $NAME
//
//Revision 1.2  1997/12/03 15:09:26  dfadmin
//Checkin for NTT Jan 98
//
//Revision 1.2  1997/04/11 13:39:50  mwiedmer
//use RWCString
//
//Revision 1.1  1997/04/10 09:14:50  dfadmin
//Initial revision
//
//Revision 1.1  1997/04/04 14:42:14  mwiedmer
//first release
//
//-----------------------------------------------------------------------------

#ifndef DFC_DBDATA_H
#define DFC_DBDATA_H

// includes from this library
// includes from other ESO libraries
#include <CorBase.h>
#include <CorBool.h>
#include <CorRef.h>
#include <CorStream.h>
#include "DfsCString.h"
// includes from other libraries
#include <msql.h>
// system includes


// typedef, extern, enums
// variables: consts, statics, exported variables (declared extern elsewhere)
// local forward function declarations
class CorUnitTest;

/// A database data class.
class DfcDbData : public CorBase {
  /**
  {\footnotesize $Id: DfcDbData.h,v 1.2 2004/10/26 15:23:54 nferguso Exp $ } \\

  {\large SYNOPSIS} \\
  \begin{verbatim}
    #include <DfcDbData.h>
  
    DfcDbData myObject;
  \end{verbatim}

  {\large DESCRIPTION} \\
  This class offers the services to get at individual components of
  data in a database.

  {\large CAUTIONS} \\
  <optional> \\

  {\large EXAMPLES} \\
  <optional> \\

  {\large SEE ALSO} \\
  <optional> \\
  \Ref{CorBase}\\
  */

public:

  /// 
  DfcDbData(
    /** {\large Purpose} \\
    The default c'tor.

    {\large Preconditions} \\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Exceptions}\\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Arguments} \\
    */
    ///
    m_result* anEntry = 0
    /** result of a query */
  );
    

  /// 
  DfcDbData(
    /** {\large Purpose} \\
    The copy c'tor creates a new instance from a reference.

    {\large Preconditions} \\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Exceptions}\\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Arguments}\\
    */
    ///
    const DfcDbData& aRef
    /** the reference instance */
  );
    

  /// 
  DfcDbData& operator=(
    /** {\large Purpose} \\
    The assignment operator makes this instance look like another one.

    {\large Preconditions} \\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Returns}\\
    A reference to this instance.

    {\large Exceptions}\\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Arguments}\\
    */
    ///
    const DfcDbData& aRef
    /** the reference instance */
  );
    

  ///
  virtual ~DfcDbData();
  /** {\large Purpose} \\
  The d'tor.
  
  {\large Preconditions} \\
  \begin{itemize}
  \item Itemize this section if necessary. Remove itemization otherwise.
  \end{itemize}
  
  {\large Exceptions}\\
  \begin{itemize}
  \item Itemize this section if necessary. Remove itemization otherwise.
  \end{itemize}
  */


  ///
  int getNumberOfEntries() const;
  /** {\large Purpose} \\
  Query the number of entries this instance is handling.

  {\large Preconditions} \\
  \begin{itemize}
  \item Itemize this section if necessary. Remove itemization otherwise.
  \end{itemize}

  {\large Returns}\\
  This function returns the number of entries.

  {\large Exceptions}\\
  \begin{itemize}
  \item Itemize this section if necessary. Remove itemization otherwise.
  \end{itemize}
  */


  ///
  DfsCString getNextEntry() const;
  /** {\large Purpose} \\
  Query the next entry handled by this instance.

  {\large Preconditions} \\
  \begin{itemize}
  \item Itemize this section if necessary. Remove itemization otherwise.
  \end{itemize}

  {\large Returns}\\
  This function returns the next entry or an empty sting ("") if there is
  no entry or no more entries.

  {\large Exceptions}\\
  \begin{itemize}
  \item Itemize this section if necessary. Remove itemization otherwise.
  \end{itemize}
  */


  ///
  m_field* getNextColumn() const;
  /** {\large Purpose} \\
  Query the next field in the dataset.

  {\large Preconditions} \\
  \begin{itemize}
  \item Itemize this section if necessary. Remove itemization otherwise.
  \end{itemize}

  {\large Returns}\\
  This function returns the next field.

  {\large Exceptions}\\
  \begin{itemize}
  \item Itemize this section if necessary. Remove itemization otherwise.
  \end{itemize}
  */


  ///
  int getNumberOfColumns() const;
  /** {\large Purpose} \\
  Query the number of the fields in this dataset.

  {\large Preconditions} \\
  \begin{itemize}
  \item Itemize this section if necessary. Remove itemization otherwise.
  \end{itemize}

  {\large Returns}\\
  This function returns the nyumber of fields available.

  {\large Exceptions}\\
  \begin{itemize}
  \item Itemize this section if necessary. Remove itemization otherwise.
  \end{itemize}
  */


protected:

  ///
  void become(
    /** {\large Purpose} \\
    This function makes this instance look like another one.

    {\large Preconditions} \\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Exceptions}\\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Arguments}\\
    */
    ///
    const DfcDbData& aRef
    /** the reference instance */
  );
    

  ///
  CorBool clear();
  /** {\large Purpose} \\
  Clear this instance.
  
  {\large Preconditions} \\
  \begin{itemize}
  \item Itemize this section if necessary. Remove itemization otherwise.
  \end{itemize}

  {\large Exceptions}\\
  \begin{itemize}
  \item Itemize this section if necessary. Remove itemization otherwise.
  \end{itemize}
  */


private:
  friend void utest_DfcDbData(CorUnitTest& aTesT); // the test function
  DfsCString extractContent(char *Location) const;   // extract content to temp dir if paf ascii file

  m_result* mEntry;       // query results
  CorRef*   mRefCounter;  // number of times this dataset is used
};

#endif // DFC_DBDATA_H
