//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// COPYRIGHT (c) 1996 European Southern Observatory
// LICENSE
//
// PROJECT:   VLT Data Flow System
// AUTHOR:    Jeremy Maxfield
// SUBSYSTEM: Dataflow core
// CI NUMBER: DFS-DFC-XXX
//
// $Revision: 1.2 $
// $Log: DfcDefinitionFile.h,v $
// Revision 1.2  2004/10/26 15:23:54  nferguso
// Temporary check-in for repository move.
//
// Revision 1.1  2004/09/06 14:35:22  cguirao
// *** empty log message ***
//
// Revision 1.1  2004/09/02 14:35:20  cguirao
// *** empty log message ***
//
// Revision 1.1  2004/06/24 13:12:15  cguirao
// First check in
//
// Revision 1.2  1998/06/30 08:57:40  dataflow
// Removing $NAME
//
// Revision 1.1  1996/12/20 11:40:49  dfadmin
// Initial revision
//
//
//-----------------------------------------------------------------------------

#ifndef _DFC_DEFINITION_FILE_H_
#define _DFC_DEFINITION_FILE_H_

#include <iostream>
#include <fstream>
#include <CompilerFixes.h>
#include <DfcParseString.h>
#include <DfcFileIdentifier.h>

class DfcDefinitionFile
{
   public:
      DfcDefinitionFile();

      DfcDefinitionFile(const DfcDefinitionFile& other);

      DfcDefinitionFile& operator=(const DfcDefinitionFile& other);

      int operator==(const DfcDefinitionFile& other);

      DfsCString getFilename()const;
      DfsCString getInstrument()const;
      DfsCString getName()const;
      DfsCString getVersion()const;

      virtual bool open(const DfsCString& name);

      virtual void testPrint(std::ostream& outStream)const;

   protected:
      DfcParseString fileContents;

   private:
      bool readIdentifier();

      std::ifstream   fileStream;
      DfsCString filename;
      DfcFileIdentifier identifier;
};

#endif

