//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// COPYRIGHT (c) 1996 European Southern Observatory
// LICENSE
//
// PROJECT:   VLT Data Flow System
// AUTHOR:    Jeremy Maxfield
// SUBSYSTEM: Dataflow core
// CI NUMBER: DFS-DFC-XXX
//
// $Revision: 1.2 $
// $Log: DfcEventRule.h,v $
// Revision 1.2  2004/10/26 15:23:54  nferguso
// Temporary check-in for repository move.
//
// Revision 1.1  2004/09/06 14:35:22  cguirao
// *** empty log message ***
//
// Revision 1.1  2004/09/02 14:35:20  cguirao
// *** empty log message ***
//
// Revision 1.1  2004/06/24 13:12:15  cguirao
// First check in
//
// Revision 1.2  1998/06/30 08:57:41  dataflow
// Removing $NAME
//
// Revision 1.1  1996/12/20 11:40:50  dfadmin
// Initial revision
//
//-----------------------------------------------------------------------------

#ifndef _DFC_EVENT_RULE_H_
#define _DFC_EVENT_RULE_H_

#include "DfsTValSlist.h"
#include <DfcParsable.h>
#include <DfcParseString.h>
#include <DfcCaseExpression.h>

class DfcEventRule: public DfcParsable
{
   public:

     DfcEventRule();

     DfcEventRule(const DfcEventRule& other);
     DfcEventRule& operator=(const DfcEventRule& other);
     int  operator==(const DfcEventRule& other);

     DfsCString getEvent()const;
     DfsCString getSelector()const;
     DfsTValSlist<DfcCaseExpression> getCases()const;

     bool parse(DfcParseString& fileAsString);

     void testPrint(std::ostream& outStream)const;

   private:
     DfsCString event;   
     DfsCString selector;

     DfsTValSlist<DfcCaseExpression> caseList;

     DfsCString CATCH_STRING;
     DfsCString SWITCH_STRING;
};
#endif
