//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// COPYRIGHT (c) 1996 European Southern Observatory
// LICENSE
//
// PROJECT:   VLT Data Flow System
// AUTHOR:    Jeremy Maxfield
// SUBSYSTEM: Dataflow core
// CI NUMBER: DFS-DFC-XXX
//
// $Revision: 1.2 $
// $Log: DfcEventRuleFile.h,v $
// Revision 1.2  2004/10/26 15:23:54  nferguso
// Temporary check-in for repository move.
//
// Revision 1.1  2004/09/06 14:35:22  cguirao
// *** empty log message ***
//
// Revision 1.1  2004/09/02 14:35:20  cguirao
// *** empty log message ***
//
// Revision 1.1  2004/06/24 13:12:15  cguirao
// First check in
//
// Revision 1.2  1998/06/30 08:57:42  dataflow
// Removing $NAME
//
// Revision 1.1  1996/12/20 11:40:50  dfadmin
// Initial revision
//
//
//-----------------------------------------------------------------------------

#ifndef _DFC_EVENT_RULE_FILE_H_
#define _DFC_EVENT_RULE_FILE_H_

#include <iostream>
#include <DfcEventRule.h>
#include <DfcParseString.h>
#include <DfcDefinitionFile.h>
#include <CompilerFixes.h>

class DfcEventRuleFile : public DfcDefinitionFile
{
   public:
      DfcEventRuleFile();

      DfcEventRuleFile(const DfcEventRuleFile& other);

      DfcEventRuleFile& operator=(const DfcEventRuleFile& other);

      int operator==(const DfcEventRuleFile& other);

      DfsTValSlist<DfcEventRule> getRules()const;

      bool open(const DfsCString& name);

      void testPrint(std::ostream& outStream)const;

   private:
      DfsTValSlist<DfcEventRule> ruleList;
};

#endif

