//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// COPYRIGHT (c) 1996 European Southern Observatory
// LICENSE
//
// PROJECT:   VLT Data Flow System
// AUTHOR:    Jeremy Maxfield
// SUBSYSTEM: Pipeline
// CI NUMBER: DFS-DFC-XXX
//
// $Revision: 1.2 $
// $Log: DfcFileIdentifier.h,v $
// Revision 1.2  2004/10/26 15:23:54  nferguso
// Temporary check-in for repository move.
//
// Revision 1.1  2004/09/06 14:35:22  cguirao
// *** empty log message ***
//
// Revision 1.1  2004/09/02 14:35:20  cguirao
// *** empty log message ***
//
// Revision 1.1  2004/06/24 13:12:15  cguirao
// First check in
//
// Revision 1.2  1998/06/30 08:57:42  dataflow
// Removing $NAME
//
// Revision 1.1  1996/12/20 11:40:51  dfadmin
// Initial revision
//
//
//-----------------------------------------------------------------------------

#ifndef _DFC_FILE_IDENTIFIER_H_
#define _DFC_FILE_IDENTIFIER_H_

#include <iostream>
#include <CompilerFixes.h>
#include <DfcParsable.h>
#include <DfcParseString.h>

class DfcFileIdentifier : public DfcParsable
{
   public:
      DfcFileIdentifier();

      DfcFileIdentifier(const DfcFileIdentifier& other);

      DfcFileIdentifier& operator=(const DfcFileIdentifier& other);

      int operator==(const DfcFileIdentifier& other);

      DfsCString getInstrument()const;
      DfsCString getName()const;
      DfsCString getVersion()const;

      bool parse(DfcParseString& parseString);
      void testPrint(std::ostream& outStream)const;

   private:

      DfsCString INSTRUMENT_STRING;      
      DfsCString NAME_STRING;      
      DfsCString VERSION_STRING;      

      DfsCString instrument; 
      DfsCString name;
      DfsCString version; 
};

#endif

