//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//COPYRIGHT (c) 1997 European Southern Observatory
//LICENSE
//
//PROJECT:   VLT Data Flow System
//AUTHOR:    Preben Grosbol - ESO/DMD/DPG
//SUBSYSTEM: Data Flow Core
//CI NUMBER: DFC-TMP-001
//
//$Revision: 1.1 $
//$Log: DfcFits.h,v $
//Revision 1.1  2004/09/06 14:35:22  cguirao
//*** empty log message ***
//
//Revision 1.1  2004/09/02 14:35:20  cguirao
//*** empty log message ***
//
//Revision 1.1  2004/06/24 13:12:15  cguirao
//First check in
//
//Revision 1.5  2002/07/03 10:05:06  dataflow
//Compatible with g++ 3.0.4 CG
//
//Revision 1.4  1999/08/06 14:30:32  dataflow
//Changes for new egcs compiler.CG
//
//Revision 1.3  1999/06/21 14:16:59  pgrosbol
//add FILE_NOTFITS definition
//
//Revision 1.2  1998/06/30 08:57:43  dataflow
//Removing $NAME
//
//Revision 1.1  1997/04/15 13:59:39  dfadmin
//Initial revision
//
//
//-----------------------------------------------------------------------------

#ifndef DFC_FITS_H
#define DFC_FITS_H

class DfcFits{

public:
  static const int  FITS_ERROR   =    -2;
  static const int  FITS_FALSE   =    -1;
  static const int  FITS_UNKNOWN =     0;
  static const int  FITS_IMAGE   =     1;
  static const int  FITS_RGROUP  =     2;
  static const int  FITS_ATABLE  =     3;
  static const int  FITS_BTABLE  =     4;

  static const int  FITS_CARD    =    80;
  static const int  FITS_RECORD  =  2880;

  static const int  FILE_OK      =     0;
  static const int  FILE_ERROR   =    -1;
  static const int  FILE_NOTFITS =    -2;

  static const int  KWS_OK       =     0;
  static const int  KWS_ERROR    =    -1;

  static const char KWT_NONE     =  '\0';
  static const char KWT_END      =   'E';
  static const char KWT_COMMENT  =   'C';
  static const char KWT_BOOLEAN  =   'B';
  static const char KWT_INTEGER  =   'I';
  static const char KWT_REAL     =   'R';
  static const char KWT_STRING   =   'S';
};

#endif // DFC_FITS_H
