//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//COPYRIGHT (c) 1997 European Southern Observatory
//LICENSE
//
//PROJECT:   VLT Data Flow System
//AUTHOR:    Preben Grosbol - ESO/DMD/DPG
//SUBSYSTEM: Data FlowCore
//CI NUMBER: DFC-TMP-001
//
//$Revision: 1.2 $
//$Log: DfcFitsFile.h,v $
//Revision 1.2  2004/10/26 15:23:54  nferguso
//Temporary check-in for repository move.
//
//Revision 1.1  2004/09/06 14:35:22  cguirao
//*** empty log message ***
//
//Revision 1.1  2004/09/02 14:35:20  cguirao
//*** empty log message ***
//
//Revision 1.1  2004/06/24 13:12:15  cguirao
//First check in
//
//Revision 1.3  2002/07/03 10:05:05  dataflow
//Compatible with g++ 3.0.4 CG
//
//Revision 1.2  1998/06/30 08:57:43  dataflow
//Removing $NAME
//
//Revision 1.1  1997/04/15 13:59:39  dfadmin
//Initial revision
//
//
//-----------------------------------------------------------------------------

#ifndef DFC_FITSFILE_H
#define DFC_FITSFILE_H

#include <DfcFits.h>
#include <DfcFitsHDunit.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>
#include "DfsCString.h"
#include "DfsTPtrSlist.h"

// typedef, extern, enums
// variables: consts, statics, exported variables (declared extern elsewhere)
// local forward function declarations
//class DfcFitsUnitTest; // the unit test class

/// A simple class 
class DfcFitsFile{
  /**
   {\footnotesize $Id: DfcFitsFile.h,v 1.2 2004/10/26 15:23:54 nferguso Exp $ } \\

   {\large SYNOPSIS} \\
   \begin{verbatim}
   #include <DfcFitsFile.h> 
   \end{verbatim}

   {\large DESCRIPTION} \\
   This text serves as an example for the documentation of a class definition

   {\large CAUTIONS} \\
   <optional> \\

   {\large EXAMPLES} \\
   <optional> \\

   {\large SEE ALSO} \\
   <optional> \\
   \Ref{DfcClass}\\
  */

public:
  /// 
  DfcFitsFile(const char* file);

  ///
  ~DfcFitsFile();

  ///
  DfcFitsHDunit* getHDunit(int no = 0);

  ///
  int getNoHDunits();

  ///
  int getStatus();

private:
  int                          status;      // Status of FITS file
  int                          noHDunits;   // No. of HDunits
  std::ifstream*               fitsfile;    // FITS file as istream
  DfsTPtrSlist<DfcFitsHDunit>  hdulist;     // List of HDunits in file
};

#endif // DFC_FITSFILE_H
