//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//COPYRIGHT (c) 1997 European Southern Observatory
//LICENSE
//
//PROJECT:   VLT Data Flow System
//AUTHOR:    Preben Grosbol - ESO/DMD/DPG
//SUBSYSTEM: Data Flow Core
//CI NUMBER: DFC-TMP-001
//
//$Revision: 1.2 $
//$Log: DfcFitsHeader.h,v $
//Revision 1.2  2004/10/26 15:23:54  nferguso
//Temporary check-in for repository move.
//
//Revision 1.1  2004/09/06 14:35:22  cguirao
//*** empty log message ***
//
//Revision 1.1  2004/09/02 14:35:20  cguirao
//*** empty log message ***
//
//Revision 1.1  2004/06/24 13:12:15  cguirao
//First check in
//
//Revision 1.3  2002/07/03 10:05:05  dataflow
//Compatible with g++ 3.0.4 CG
//
//Revision 1.2  1998/06/30 08:57:44  dataflow
//Removing $NAME
//
//Revision 1.1  1997/04/15 13:59:39  dfadmin
//Initial revision
//
//
//-----------------------------------------------------------------------------

#ifndef DFC_FITSHEADER_H
#define DFC_FITSHEADER_H

#include <DfcFits.h>
#include <DfcFitsKeyword.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>
#include "DfsCString.h"
#include "DfsTPtrSlist.h"

// typedef, extern, enums
// variables: consts, statics, exported variables (declared extern elsewhere)
// local forward function declarations
//class DfcFitsUnitTest; // the unit test class

/// A simple class 
class DfcFitsHeader{
  /**
   {\footnotesize $Id: DfcFitsHeader.h,v 1.2 2004/10/26 15:23:54 nferguso Exp $ } \\

   {\large SYNOPSIS} \\
   \begin{verbatim}
   #include <DfcFitsHeader.h> 
   \end{verbatim}

   {\large DESCRIPTION} \\
   This text serves as an example for the documentation of a class definition

   {\large CAUTIONS} \\
   <optional> \\

   {\large EXAMPLES} \\
   <optional> \\

   {\large SEE ALSO} \\
   <optional> \\
   \Ref{DfcClass}\\
  */

public:
  /// 
  DfcFitsHeader(std::ifstream* file);

  ///
  ~DfcFitsHeader();

  ///
  DfcFitsKeyword* getKeyword(int no);

  ///
  DfcFitsKeyword* getKeyword(char* kwname);

  ///
  int getType();

  ///
  int getNoKeywords();

private:
  int                           hType;      // Type of FITS Header
  long                          noKeywords; // No. of FITS keywords
  DfsTPtrSlist<DfcFitsKeyword>  kwlist;     // List of keywords in header
};

#endif // DFC_FITSHEADER_H
