#ifndef DFCFRAMEPROXY_H
#define DFCFRAMEPROXY_H

#include "DfsCString.h"
#include "DfsTValSlist.h"

class DfcFrameProxy {
          public:
             DfcFrameProxy(){keylist.clear();}
             DfcFrameProxy(const DfsCString& filename, 
			   const DfsTValSlist<DfsCString>& akeylist);
             DfcFrameProxy(const DfsCString& filename);
             DfcFrameProxy(const DfcFrameProxy& other);
 
             DfcFrameProxy& operator = (const DfcFrameProxy& cc);
     
             DfsCString getFilename() const;
             void setFilename(const DfsCString& recipe);

             DfsCString getInstrument() const;
             DfsCString getTplStart() const;
             int getInsMode();
	     int isEndOfTemplate(const DfcFrameProxy& other);
             DfsTValSlist<DfsCString> getKeylist() const;
             void setKeylist(const DfsTValSlist<DfsCString>& akeylist);

             void saveAsRecord(DfsCString& record) ;
          private:
             DfsTValSlist<DfsCString> keylist; 
             DfsCString filename;
             DfsCString instrument;
             int tpl_nexp;
	     int tpl_expno;
             int has_start;
             int ins_mode;
             DfsCString tpl_start;
};
#endif
