//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// COPYRIGHT (c) 1996 European Southern Observatory
// LICENSE
//
// PROJECT:   VLT Data Flow System
// AUTHOR:    Jeremy Maxfield
// SUBSYSTEM: Dataflow core
// CI NUMBER: DFS-DFC-XXX
//
// $Revision: 1.2 $
// $Log: DfcFunctionCall.h,v $
// Revision 1.2  2004/10/26 15:45:27  nferguso
// temp
//
// Revision 1.1  2004/09/06 14:35:22  cguirao
// *** empty log message ***
//
// Revision 1.1  2004/09/02 14:35:20  cguirao
// *** empty log message ***
//
// Revision 1.1  2004/06/24 13:12:15  cguirao
// First check in
//
// Revision 1.2  1998/06/30 08:57:45  dataflow
// Removing $NAME
//
// Revision 1.1  1996/12/20 11:40:51  dfadmin
// Initial revision
//
//-----------------------------------------------------------------------------

#ifndef _DFC_FUNCTION_CALL_H_
#define _DFC_FUNCTION_CALL_H_

#include "DfsTValSlist.h"
#include <DfcParsable.h>
#include <DfcParseString.h>

class DfcFunctionCall: public DfcParsable
{
   public:

     DfcFunctionCall();

     DfcFunctionCall(const DfcFunctionCall& other);
     DfcFunctionCall& operator=(const DfcFunctionCall& other);
     int  operator==(const DfcFunctionCall& other);

     DfsCString getName()const;
     DfsTValSlist<DfsCString> getParameters()const;
     DfsCString              getParametersAsString()const;
 
     bool parse(DfcParseString& inString);

     void testPrint(std::ostream& outStream)const;

   private:
     DfsCString name;
     DfsTValSlist<DfsCString> parameterList ;
};

#endif
