//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//COPYRIGHT (c) 1996 European Southern Observatory
//LICENSE
//
//PROJECT:   VLT On-line Data Flow
//AUTHOR:    <Alisdair Manning - ESO-DMD-DPG>
//SUBSYSTEM: <df-core>
//
//$Revision: 1.2 $
//$Log: DfcGlobals.h,v $
//Revision 1.2  2004/10/26 15:45:27  nferguso
//temp
//
//Revision 1.1  2004/09/06 14:35:22  cguirao
//*** empty log message ***
//
//Revision 1.1  2004/09/02 14:35:20  cguirao
//*** empty log message ***
//
//Revision 1.1  2004/06/24 13:12:15  cguirao
//First check in
//
//Revision 1.3  2002/07/03 10:05:04  dataflow
//Compatible with g++ 3.0.4 CG
//
//Revision 1.2  1998/06/30 08:57:46  dataflow
//Removing $NAME
//
//Revision 1.1  1996/12/20 11:40:51  dfadmin
//Initial revision
//
//Revision 1.1  1996/09/10 07:48:19  amanning
//first release - prior to first design review
//
//-----------------------------------------------------------------------------

//
// This file contains any global data that must unfortunately exist in the 
// subsystem. Global data is not anticipated. However, by having this file
// present it is a handy place to store any muck that is needed in order to
// perform the first draft implementation using MIDAS. The header files 
// should make no mention of MIDAS, or MIDAS specific implementation details
// whatsoever. Therefore MIDAS related errors will only be signalled by the 
// most generic exception class possible which can be used as a catch all
// when the implementation of the frame subsystem is used.
// 
// Also note, that some of this page is not documented with doc++ because 
// it concerns implementation details only which should not be observed by 
// the users.
//

#ifndef DFC_GLOBALS_H
#define DFC_GLOBALS_H

//#include <String.h>
//#include "DfcString.h"
//#include "CorBool.h"
#include "DfsCString.h"     // DFS string class
#include "DfsConstants.h"   // For DfsBoolean type

//typedef String DFC_STRING;
//typedef DfcString DFC_STRING;
typedef DfsCString DFC_STRING;

// typedef CorBool DFC_BOOL;
// const DFC_BOOL DFC_TRUE = corTRUE;
// const DFC_BOOL DFC_FALSE = corFALSE;
typedef DfsBoolean DFC_BOOL;
const DFC_BOOL DFC_TRUE = true;
const DFC_BOOL DFC_FALSE = false;

//
// Valid numerical types. Suspect these should be placed in a class of their own
// However, for the moment I'm not going to do this.
// Unfortunately parts of the code are going to have to be very non-OO and rely on switch-on-type behaviour. This is due to the lack of concern about types.
//
/// 32 bit floating point number
typedef double DFC_REAL_32;

/// 64 bit floating point number
typedef float DFC_REAL_64;

/// unsigned 8 bit integer
typedef unsigned char DFC_INT_UNSIGN_8;

/// unsigned 16 bit integer
typedef unsigned int DFC_INT_UNSIGN_16;

/// signed 16 bit integer
typedef signed int DFC_INT_SIGN_16;

/// 32 bit integer, two's complement representation
typedef int DFC_INT_2C_32;

/// 64 bit integer, two's complement representation
typedef long DFC_INT_2C_64;


//
// hacks for compilation purposes
//
template <class T> class DfcVector {};
class DfcCoordSys {};
class DfcCoordSysInterface {};
class DfcTable {};
class DfcTableInterface {};
class DfcFrame {};
class DfcFrameInterface {};
class DfcTime {};
class DfcTimeInterface {};
class DfcEnumerated {};
class DfcEnumeratedInterface {};
class DfcTarget {};
class DfcTargetInterface {};
class DfcIO_Strategy {};

// This implementation is not based upon MIDAS
// #include "DfcMidasSession.h" 

#endif // DFC_GLOBALS_H


