//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//COPYRIGHT (c) 1996 European Southern Observatory
//LICENSE
//
//PROJECT:   VLT On-line Data Flow
//AUTHOR:    Michael Wiedmer - ESO/DMD/DPG
//SUBSYSTEM: Dataflow Core
//
//$Revision: 1.2 $
//$Log: DfcIdf.h,v $
//Revision 1.2  2004/10/26 15:45:27  nferguso
//temp
//
//Revision 1.1  2004/09/06 14:35:22  cguirao
//*** empty log message ***
//
//Revision 1.1  2004/09/02 14:35:20  cguirao
//*** empty log message ***
//
//Revision 1.1  2004/06/24 13:12:15  cguirao
//First check in
//
//Revision 1.2  1998/06/30 08:57:46  dataflow
//Removing $NAME
//
//Revision 1.1  1997/04/10 09:15:31  dfadmin
//Initial revision
//
//Revision 1.1  1997/03/18 10:56:57  mwiedmer
//make DfcDB become DfcDb,
//DfcDBManager to DfcDbManager, DfcIDF to DfcIdf
//and use environment variable to determine
//the DFC_DB_ROOT
//
//Revision 1.1  1996/12/13 14:23:47  mwiedmer
//first release
//
//-----------------------------------------------------------------------------

#ifndef DFC_IDF_H
#define DFC_IDF_H

// includes from this library
// includes from other ESO libraries
#include <CorBase.h>
#include <CorStream.h>
#include "DfsCString.h"
// includes from other libraries
// system includes

// typedef, extern, enums
// variables: consts, statics, exported variables (declared extern elsewhere)
// local forward function declarations
class CorUnitTest;
class CorPersistent;
class CorStream;

/// A simple IDF class 
class DfcIdf : public CorBase {
  /**
  {\footnotesize $Id: DfcIdf.h,v 1.2 2004/10/26 15:45:27 nferguso Exp $ } \\

  {\large SYNOPSIS} \\
  \begin{verbatim}
    #include <DfcIdf.h>
  
    DfcIdf myObject;
  \end{verbatim}

  {\large DESCRIPTION} \\
  This class models the Instrument Definition File. 
  {\large CAUTIONS} \\
  <optional> \\

  {\large EXAMPLES} \\
  <optional> \\

  {\large SEE ALSO} \\
  <optional> \\
  \Ref{CorSignature}\\
  \Ref{CorBase}\\
  */

public:

  
  /// 
  DfcIdf(
    /** {\large Purpose} \\
    The c'tor.

    {\large Preconditions} \\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Exceptions}\\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}
    {\large Arguments}\\
    */
    ///
    CorStream& aStream
    /** stream to use */
  );


  ///
  ~DfcIdf();
  /** {\large Purpose} \\
  The d'tor.
  
  {\large Preconditions} \\
  \begin{itemize}
  \item Itemize this section if necessary. Remove itemization otherwise.
  \end{itemize}
  
  {\large Exceptions}\\
  \begin{itemize}
  \item Itemize this section if necessary. Remove itemization otherwise.
  \end{itemize}
  */


  ///
  void use(
    /** {\large Purpose} \\
    Attach s stream to this IDF.

    {\large Preconditions} \\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Exceptions}\\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Arguments}\\
    */
    ///
    CorStream& aStream
    /** stream to use */
  );


  ///
  void write(
    /** {\large Purpose} \\
    Write the supplied string into the attached IDF.

    {\large Preconditions} \\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Exceptions}\\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Arguments}\\
    */
    ///
    const DfsCString& aString
    /** string to save */
  );


  ///
  void write(
    /** {\large Purpose} \\
    Write the supplied double as a string into the attached IDF.

    {\large Preconditions} \\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Exceptions}\\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Arguments}\\
    */
    ///
    const double aDouble
    /** double to save */
  );


  ///
  void write(
    /** {\large Purpose} \\
    Write the supplied integer as a string into the attached IDF.

    {\large Preconditions} \\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Exceptions}\\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Arguments}\\
    */
    ///
    const int anInt
    /** integer to save */
  );


  ///
  DfsCString nextToken();
  /** {\large Purpose} \\
  Read one word from the attached stream and move to the next one.

  {\large Preconditions} \\
  \begin{itemize}
  \item Itemize this section if necessary. Remove itemization otherwise.
  \end{itemize}

  {\large Returns}\\
  This function returns the next word from the stream.

  {\large Exceptions}\\
  \begin{itemize}
  \item Itemize this section if necessary. Remove itemization otherwise.
  \end{itemize}
  */


  ///
  DfsCString thisToken();
  /** {\large Purpose} \\
  Read one word.

  {\large Preconditions} \\
  \begin{itemize}
  \item Itemize this section if necessary. Remove itemization otherwise.
  \end{itemize}

  {\large Returns}\\
  This function returns the current word from the stream.

  {\large Exceptions}\\
  \begin{itemize}
  \item Itemize this section if necessary. Remove itemization otherwise.
  \end{itemize}
  */


  ///
  DfsCString nextString();
  /** {\large Purpose} \\
  Read a string from the attached stream.

  {\large Preconditions} \\
  \begin{itemize}
  \item Itemize this section if necessary. Remove itemization otherwise.
  \end{itemize}

  {\large Returns}\\
  This function returns the next string from the stream.

  {\large Exceptions}\\
  \begin{itemize}
  \item Itemize this section if necessary. Remove itemization otherwise.
  \end{itemize}
  */


  ///
  DfsCString stuffRest();
  /** {\large Purpose} \\
  Return the rest of the current line and drop it, ie clear the current
  line.

  {\large Preconditions} \\
  \begin{itemize}
  \item Itemize this section if necessary. Remove itemization otherwise.
  \end{itemize}

  {\large Returns}\\
  This function returns a string representing the rest of the line.

  {\large Exceptions}\\
  \begin{itemize}
  \item Itemize this section if necessary. Remove itemization otherwise.
  \end{itemize}
  */

  ///
  DfsCString restOfLine();
  /** {\large Purpose} \\
  Return the rest of the current line.

  {\large Preconditions} \\
  \begin{itemize}
  \item Itemize this section if necessary. Remove itemization otherwise.
  \end{itemize}

  {\large Returns}\\
  This function returns a string representing the rest of the line.

  {\large Exceptions}\\
  \begin{itemize}
  \item Itemize this section if necessary. Remove itemization otherwise.
  \end{itemize}
  */


  ///
  DfsCString thisLine();
  /** {\large Purpose} \\
  Return the original line.

  {\large Preconditions} \\
  \begin{itemize}
  \item Itemize this section if necessary. Remove itemization otherwise.
  \end{itemize}

  {\large Returns}\\
  This function returns a string representing the original line read.

  {\large Exceptions}\\
  \begin{itemize}
  \item Itemize this section if necessary. Remove itemization otherwise.
  \end{itemize}
  */


  ///
  void resetLine();
  /** {\large Purpose} \\
  Restore the current line buffer.

  {\large Preconditions} \\
  \begin{itemize}
  \item Itemize this section if necessary. Remove itemization otherwise.
  \end{itemize}

  {\large Exceptions}\\
  \begin{itemize}
  \item Itemize this section if necessary. Remove itemization otherwise.
  \end{itemize}
  */


  ///
  unsigned int getLineNumber();
  /** {\large Purpose} \\
  Query the current line number.

  {\large Preconditions} \\
  \begin{itemize}
  \item Itemize this section if necessary. Remove itemization otherwise.
  \end{itemize}

  {\large Returns}\\
  This function returns an integer representing the current line number.

  {\large Exceptions}\\
  \begin{itemize}
  \item Itemize this section if necessary. Remove itemization otherwise.
  \end{itemize}
  */


  ///
  void stripComment(
    /** {\large Purpose} \\
    Strips the comment of a line. Currently only single line comments are
    supported.

    {\large Preconditions} \\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Exceptions}\\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Arguments}\\
    */
    ///
    DfsCString& aLine
    /** line to strip of comments */
  );


  ///
  CorBool loadNewLine(
    /** {\large Purpose} \\

    Load a new line from the file and stores its contents in the
    supplied line buffer. The contents are stripped of leading white
    space and comments. Empty lines are ignored.

    {\large Preconditions} \\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Returns} \\
    This function returns corTRUE if it could successfully load a new line.

    {\large Exceptions}\\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Arguments}\\ */
    ///
    DfsCString& aLine
    /** puts the contents here */
  );


protected:

  ///
  static void save(
    /** {\large Purpose} \\
    Save out the supplied value into an IDF. Produce apropriate keywords, etc.

    {\large Preconditions} \\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Exceptions}\\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Arguments}\\
    */
    ///
    const CorPersistent* aVal,
    /** value to save */
    ///
    CorStream& aStream
    /** file to save to */
  );


  ///
  static void save(
    /** {\large Purpose} \\
    Save out the supplied value into an IDF. Produce apropriate keywords, etc.

    {\large Preconditions} \\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Exceptions}\\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Arguments}\\
    */
    ///
    const DfsCString& aVal,
    /** value to save */
    ///
    CorStream& aStream
    /** file to save to */
  );


  ///
  static void save(
    /** {\large Purpose} \\
    Save out the supplied value into an IDF. Produce apropriate keywords, etc.

    {\large Preconditions} \\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Exceptions}\\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Arguments}\\
    */
    ///
    int aVal,
    /** value to save */
    ///
    CorStream& aStream
    /** file to save to */
  );


  ///
  static void save(
    /** {\large Purpose} \\
    Save out the supplied value into an IDF. Produce apropriate keywords, etc.

    {\large Preconditions} \\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Exceptions}\\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Arguments}\\
    */
    ///
    double aVal,
    /** value to save */
    ///
    CorStream& aStream
    /** file to save to */
  );



  ///
  static void load(
    /** {\large Purpose} \\
    Load a value from an IDF.

    {\large Preconditions} \\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Returns}\\
    This function returns something?

    {\large Exceptions}\\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Arguments}\\
    */
    ///
    CorPersistent* aVal,
    /** value to read */
    ///
    CorStream& aStream
    /** file to read value from */
  );


  ///
  static void load(
    /** {\large Purpose} \\
    Load a value from an IDF.

    {\large Preconditions} \\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Returns}\\
    This function returns something?

    {\large Exceptions}\\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Arguments}\\
    */
    ///
    DfsCString& aVal,
    /** value to read */
    ///
    CorStream& aStream
    /** file to read value from */
  );


  ///
  static void load(
    /** {\large Purpose} \\
    Load a value from an IDF.

    {\large Preconditions} \\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Returns}\\
    This function returns something?

    {\large Exceptions}\\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Arguments}\\
    */
    ///
    int& aVal,
    /** value to read */
    ///
    CorStream& aStream
    /** file to read value from */
  );


  ///
  static void load(
    /** {\large Purpose} \\
    Load a value from an IDF.

    {\large Preconditions} \\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Returns}\\
    This function returns something?

    {\large Exceptions}\\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Arguments}\\
    */
    ///
    double& aVal,
    /** value to read */
    ///
    CorStream& aStream
    /** file to read value from */
  );


  ///
  DfsCString queryType(
    /** {\large Purpose} \\
    Query the next expected type.

    {\large Preconditions} \\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Returns}\\
    This function returns something?

    {\large Exceptions}\\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}
    
    {\large Arguments}\\
    */
    ///
    CorStream& aStream
    /** stream that defines the type */
  );


  /// 
  DfcIdf(
    /** {\large Purpose} \\
    The copy c'tor creates a new instance from a reference.

    {\large Preconditions} \\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Exceptions}\\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Arguments}\\
    */
    ///
    const DfcIdf& aRef
    /** the reference instance */
  );
    

  /// 
  DfcIdf& operator=(
    /** {\large Purpose} \\
    The assignment operator makes this instance look like another one.

    {\large Preconditions} \\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Returns}\\
    A reference to this instance.

    {\large Exceptions}\\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Arguments}\\
    */
    ///
    const DfcIdf& aRef
    /** the reference instance */
  );
    

  ///
  void become(
    /** {\large Purpose} \\
    The assignment operator makes this instance look like another one.

    {\large Preconditions} \\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Returns}\\
    A reference to this instance.

    {\large Exceptions}\\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Arguments}\\
    */
    ///
    const DfcIdf& aRef
    /** the reference instance */
  );


private:
  friend void utest_DfcIdf(CorUnitTest&);  // the unit test function

  static DfsCString mCommentBeg; // character sequence that initiates a comment
  static DfsCString mCommentEnd; // character sequence that ends a comment
  static DfsCString mWhiteSpace; // whitespace characters
  static DfsCString mTokenDelim; // token delimiter
  CorStream mStream;             // attached stream
  DfsCString mIDF;               // file contents
  DfsCString mType;              // current type
  DfsCString mLineOriginal;      // last line read
  DfsCString mLineCopy;          // characters in line still to be read
  DfsCString mLastWord;          // last word read
  unsigned int mLineNumber;      // line number
};

#endif // DFC_IDF_H
