//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// COPYRIGHT (c) 1996 European Southern Observatory
// LICENSE
//
// PROJECT:   VLT Data Flow System
// AUTHOR:    Jeremy Maxfield
// SUBSYSTEM: Dataflow core
// CI NUMBER: DFS-DFC-XXX
//
// $Revision: 1.2 $
// $Log: DfcParseString.h,v $
// Revision 1.2  2004/10/26 15:45:27  nferguso
// temp
//
// Revision 1.1  2004/09/06 14:35:23  cguirao
// *** empty log message ***
//
// Revision 1.1  2004/09/02 14:35:21  cguirao
// *** empty log message ***
//
// Revision 1.1  2004/06/24 13:12:16  cguirao
// First check in
//
// Revision 1.5  2002/07/03 10:05:08  dataflow
// Compatible with g++ 3.0.4 CG
//
// Revision 1.4  1999/08/06 14:30:33  dataflow
// Changes for new egcs compiler.CG
//
// Revision 1.3  1998/06/30 08:57:52  dataflow
// Removing $NAME
//
// Revision 1.2  1997/04/21 17:10:00  dfadmin
// corrected path cor rogue wave string
//
// Revision 1.1  1996/12/20 11:40:55  dfadmin
// Initial revision
//
//
//-----------------------------------------------------------------------------

#ifndef _DFC_PARSE_STRING_H_
#define _DFC_PARSE_STRING_H_

#include "DfsCString.h"
#include <CompilerFixes.h>

class DfcParseString : public DfsCString
{
   public:
      DfcParseString();
//      DfcParseString(const DfsCString& other);
      DfcParseString(const DfcParseString& other);

      DfcParseString& operator=(const DfcParseString& other);

      void setComment(const DfsCString& start,const DfsCString& end = "\n");

      bool expectString(const DfsCString& string);

      bool expectDelimitedString(const DfsCString& end,
                              DfsCString& string, bool suppressSpaces = false);

      bool expectDelimitedString(const  DfsCString& start, const DfsCString& end,
                              DfsCString& string, bool suppressSpaces = false);

      void skipWhiteSpace();
      void stripComments();

      int  getCurrentLine();

   private:
      void stripWhiteSpace(DfsCString& string);

      DfsCString commentStart;
      DfsCString commentEnd;

      int       lineNumber;

      DfsCString NEW_LINE;
      char       NEW_LINE_CHAR; 
      char       TAB_CHAR; 
      char       SPACE_CHAR; 
    
};
#endif

