//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// COPYRIGHT (c) 1996 European Southern Observatory
// LICENSE
//
// PROJECT:   VLT Data Flow System
// AUTHOR:    Jeremy Maxfield
// SUBSYSTEM: Dataflow core
// CI NUMBER: DFS-DFC-XXX
//
// $Revision: 1.2 $
// $Log: DfcProcess.h,v $
// Revision 1.2  2004/10/26 15:45:27  nferguso
// temp
//
// Revision 1.1  2004/09/06 14:35:23  cguirao
// *** empty log message ***
//
// Revision 1.1  2004/09/02 14:35:21  cguirao
// *** empty log message ***
//
// Revision 1.1  2004/06/24 13:12:16  cguirao
// First check in
//
// Revision 1.3  1998/06/30 08:57:52  dataflow
// Removing $NAME
//
// Revision 1.2  1997/04/21 17:10:00  dfadmin
// corrected path cor rogue wave string
//
// Revision 1.1  1996/12/20 11:40:55  dfadmin
// Initial revision
//
//
//-----------------------------------------------------------------------------
#ifndef _DFC_PROCESS_H_
#define _DFC_PROCESS_H_

#include <iostream>
#include "DfsCString.h"
#include "DfsTValSlist.h"

class DfcProcess
{
   public:
      DfcProcess();
      virtual int run(const DfsTValSlist<DfsCString>& arguments) = 0;
      virtual void testPrint(std::ostream& outStream) = 0;

   protected:
      void setArguments(const DfsTValSlist<DfsCString>& arguments);
      void printError(const DfsCString& message);
      void printMessage(const DfsCString& message);

      DfsCString              processName;
      DfsTValSlist<DfsCString> argumentList; 
};

#endif

