//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// COPYRIGHT (c) 1996 European Southern Observatory
// LICENSE
//
// PROJECT:   VLT Data Flow System
// AUTHOR:    Jeremy Maxfield
// SUBSYSTEM: Dataflow core
// CI NUMBER: DFS-DFC-XXX
//
// $Revision: 1.2 $
// $Log: DfcReductionRule.h,v $
// Revision 1.2  2004/10/26 15:45:27  nferguso
// temp
//
// Revision 1.1  2004/09/06 14:35:23  cguirao
// *** empty log message ***
//
// Revision 1.1  2004/09/02 14:35:21  cguirao
// *** empty log message ***
//
// Revision 1.1  2004/06/24 13:12:16  cguirao
// First check in
//
// Revision 1.2  1998/06/30 08:57:53  dataflow
// Removing $NAME
//
// Revision 1.1  1996/12/20 11:40:55  dfadmin
// Initial revision
//
//-----------------------------------------------------------------------------

#ifndef _DFC_REDUCTION_RULE_H_
#define _DFC_REDUCTION_RULE_H_

#include "DfsTValSlist.h"
#include <DfcParsable.h>
#include <DfcParseString.h>
#include <DfcRuleGuard.h>
#include <DfcFunctionCall.h>

class DfcReductionRule: public DfcParsable
{
   public:

     DfcReductionRule();

     DfcReductionRule(const DfcReductionRule& other);
     DfcReductionRule& operator=(const DfcReductionRule& other);
     int  operator==(const DfcReductionRule& other);

     DfsCString getName()const;
     DfsTValSlist<DfsCString> getParameters()const;
     DfsTValSlist<DfcRuleGuard> getGuards()const;
     DfcFunctionCall getAction()const;

     bool parse(DfcParseString& inString);

     void testPrint(std::ostream& outStream)const;

   private:

     DfsCString IF_STRING;
     DfsCString EXECUTE_STRING;

     DfcFunctionCall signature;   
     DfsCString parameter;
      
     DfsTValSlist<DfcRuleGuard> guardList;
     DfcFunctionCall action;
};
#endif
