//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// COPYRIGHT (c) 1996 European Southern Observatory
// LICENSE
//
// PROJECT:   VLT Data Flow System
// AUTHOR:    Jeremy Maxfield
// SUBSYSTEM: Dataflow core
// CI NUMBER: DFS-DFC-XXX
//
// $Revision: 1.2 $
// $Log: DfcReductionRuleFile.h,v $
// Revision 1.2  2004/10/26 15:45:27  nferguso
// temp
//
// Revision 1.1  2004/09/06 14:35:23  cguirao
// *** empty log message ***
//
// Revision 1.1  2004/09/02 14:35:21  cguirao
// *** empty log message ***
//
// Revision 1.1  2004/06/24 13:12:16  cguirao
// First check in
//
// Revision 1.2  1998/06/30 08:57:53  dataflow
// Removing $NAME
//
// Revision 1.1  1996/12/20 11:40:56  dfadmin
// Initial revision
//
//
//-----------------------------------------------------------------------------

#ifndef _DFC_REDUCTION_RULE_FILE_H_
#define _DFC_REDUCTION_RULE_FILE_H_

#include <iostream>
#include <DfcReductionRule.h>
#include <DfcDefinitionFile.h>
#include <DfcParseString.h>
#include <CompilerFixes.h>

class DfcReductionRuleFile : public DfcDefinitionFile
{
   public:
      DfcReductionRuleFile();

      DfcReductionRuleFile(const DfcReductionRuleFile& other);

      DfcReductionRuleFile& operator=(const DfcReductionRuleFile& other);

      int operator==(const DfcReductionRuleFile& other);


      DfsTValSlist<DfcReductionRule> getRules()const;

      bool open(const DfsCString& name);

      void testPrint(std::ostream& outStream)const;

   private:

      DfsTValSlist<DfcReductionRule> ruleList;
};

#endif

