//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// COPYRIGHT (c) 1996 European Southern Observatory
// LICENSE
//
// PROJECT:   VLT Data Flow System
// AUTHOR:    Jeremy Maxfield
// SUBSYSTEM: Dataflow core
// CI NUMBER: DFS-DFC-XXX
//
// $Revision: 1.2 $
// $Log: DfcRuleGuard.h,v $
// Revision 1.2  2004/10/26 15:45:27  nferguso
// temp
//
// Revision 1.1  2004/09/06 14:35:23  cguirao
// *** empty log message ***
//
// Revision 1.1  2004/09/02 14:35:21  cguirao
// *** empty log message ***
//
// Revision 1.1  2004/06/24 13:12:16  cguirao
// First check in
//
// Revision 1.2  1998/06/30 08:57:54  dataflow
// Removing $NAME
//
// Revision 1.1  1996/12/20 11:40:56  dfadmin
// Initial revision
//
//-----------------------------------------------------------------------------

#ifndef _DFC_RULE_GUARD_H_
#define _DFC_RULE_GUARD_H_

#include <DfcParsable.h>
#include <DfcParseString.h>
#include <DfcFunctionCall.h>

class DfcRuleGuard: public DfcParsable
{
   public:

     DfcRuleGuard();

     DfcRuleGuard(const DfcRuleGuard& other);
     DfcRuleGuard& operator=(const DfcRuleGuard& other);
     int  operator==(const DfcRuleGuard& other);

     DfsCString getParameter()const;
     DfcFunctionCall getQuery()const;
 
     bool parse(DfcParseString& inString);

     void testPrint(std::ostream& outStream)const;

   private:
     
     DfsCString parameter;
     DfcFunctionCall query;
};

#endif
