#ifndef QUCCOMPOSITEREDUCTIONRULE_H
#define QUCCOMPOSITEREDUCTIONRULE_H

#include "DfsTPtrSlist.h"
#include "DfsTValSlist.h"
#include "DfsCString.h"
#include "QucReductionRule.h"

class QucCompositeReductionRule: public QucReductionRule {
     public:
        QucCompositeReductionRule() {;}
        QucCompositeReductionRule(const DfsCString& aname) ;
        QucCompositeReductionRule(const QucCompositeReductionRule& other) ;
        QucCompositeReductionRule(const DfsCString& aname,
                                const DfsTPtrSlist<QucReductionRule>& avcr) ;

        ~QucCompositeReductionRule() {;}
         QucCompositeReductionRule& operator = 
                    (const QucCompositeReductionRule& cc);        

         DfsBoolean operator==(const QucCompositeReductionRule& cc);

         void addReductionRule(QucReductionRule* arr);
         DfsBoolean fire(const DfcObservationSummaryTable& ost,
                        const DfsCString& event,
                        const DfsCString& frame,
                        DfcSetOfFrames& sfr);
         DfsBoolean isAComposite() {return true;}
         DfsTValSlist<DfsCString> getConditionExpr() const;  
         QucAction* getReductionAction() const {return NULL;}
     private:
       DfsTPtrSlist<QucReductionRule> vcr;
}; 
#endif
