#ifndef QUCREDUCTIONRULE_H
#define QUCREDUCTIONRULE_H

#include "DfsCString.h"
#include "DfsTValSlist.h"

class QucReductionCondition;
class QucAction;
class DfcObservationSummaryTable;
class DfcSetOfFrames;
class QucReductionRule {
     public:
        QucReductionRule() {;}
        QucReductionRule(const DfsCString& aname);
        QucReductionRule(const DfsCString& aname,
                         QucReductionCondition* arc,
                         QucAction* act){;}
        ~QucReductionRule() {;}
         DfsBoolean operator==(const QucReductionRule& cc) const;
         void setName(const DfsCString& aname);
         DfsCString getName() const;

         virtual DfsBoolean fire(const DfcObservationSummaryTable& ost,
                        const DfsCString& event,
                        const DfsCString& frame,
                        DfcSetOfFrames& sfr) = 0;

         virtual DfsBoolean isAComposite() {return false;}
         virtual void setReductionCondition(QucReductionCondition* arc){;}
         virtual void setIfAction(QucAction* act){;}
         virtual void setElseAction(QucAction* act){;}
         virtual DfsTValSlist<DfsCString> getConditionExpr() const {;}
         virtual QucAction* getReductionAction() const {;}
     protected:
         DfsCString name;
};
#endif

